
ModbusSlave_calcCRC:

;ModbusSlave.c,97 :: 		static uint calcCRC(uint uintLength) {
;ModbusSlave.c,100 :: 		movff    FARG_ModbusSlave_calcCRC_uintLength,R2  // byte count in R2
	MOVFF       FARG_ModbusSlave_calcCRC_uintLength+0, R2
;ModbusSlave.c,101 :: 		lfsr     0,ModbusSlave_aryBuffer                 // point to aryBuffer
	LFSR        0, ModbusSlave_aryBuffer+0
;ModbusSlave.c,102 :: 		setf     R0                // preset CRC
	SETF        R0, 1
;ModbusSlave.c,103 :: 		setf     R1
	SETF        R1, 1
;ModbusSlave.c,104 :: 		MBgetCRC1:
MBgetCRC1:
;ModbusSlave.c,105 :: 		movf     POSTINC0,W        // xor byte with CRClo
	MOVF        POSTINC0+0, 0, 1
;ModbusSlave.c,106 :: 		xorwf    R0,F
	XORWF       R0, 1, 1
;ModbusSlave.c,107 :: 		movlw    8                 // bit count in R3
	MOVLW       8
;ModbusSlave.c,108 :: 		movwf    R3
	MOVWF       R3, 1
;ModbusSlave.c,109 :: 		MBgetCRC2:
MBgetCRC2:
;ModbusSlave.c,110 :: 		bcf      STATUS,C
	BCF         STATUS+0, 0, 1
;ModbusSlave.c,111 :: 		rrcf     R1,F
	RRCF        R1, 1, 1
;ModbusSlave.c,112 :: 		rrcf     R0,F
	RRCF        R0, 1, 1
;ModbusSlave.c,113 :: 		bnc      $+10
	BNC         $+10
;ModbusSlave.c,114 :: 		movlw    0xA0
	MOVLW       160
;ModbusSlave.c,115 :: 		xorwf    R1,F
	XORWF       R1, 1, 1
;ModbusSlave.c,116 :: 		movlw    0x01
	MOVLW       1
;ModbusSlave.c,117 :: 		xorwf    R0,F
	XORWF       R0, 1, 1
;ModbusSlave.c,118 :: 		decfsz   R3,F
	DECFSZ      R3, 1, 1
;ModbusSlave.c,119 :: 		bra      MBgetCRC2
	BRA         MBgetCRC2
;ModbusSlave.c,120 :: 		decfsz   R2,F
	DECFSZ      R2, 1, 1
;ModbusSlave.c,121 :: 		bra      MBgetCRC1
	BRA         MBgetCRC1
;ModbusSlave.c,122 :: 		return
	RETURN      0
;ModbusSlave.c,124 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
;ModbusSlave.c,125 :: 		}
L_end_calcCRC:
	RETURN      0
; end of ModbusSlave_calcCRC

ModbusSlave_coilState:

;ModbusSlave.c,137 :: 		static boolean coilState(uint uintAddress, boolean blnState) {
;ModbusSlave.c,138 :: 		if ( pCurrBlock != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState197
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L_ModbusSlave_coilState197:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState3
;ModbusSlave.c,142 :: 		uintOffset = uintAddress - pCurrBlock->uintAddress;
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_coilState_uintAddress+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_coilState_uintAddress+1, 0 
	MOVWF       R4 
;ModbusSlave.c,143 :: 		bytIndex = uintOffset / 8;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R5 
;ModbusSlave.c,144 :: 		bytBit = 1 << (uintOffset % 8);
	MOVLW       7
	ANDWF       R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVLW       1
	MOVWF       R6 
	MOVF        R0, 0 
L_ModbusSlave_coilState198:
	BZ          L_ModbusSlave_coilState199
	RLCF        R6, 1 
	BCF         R6, 0 
	ADDLW       255
	GOTO        L_ModbusSlave_coilState198
L_ModbusSlave_coilState199:
;ModbusSlave.c,146 :: 		if ( blnState == TRUE ) {
	MOVF        FARG_ModbusSlave_coilState_blnState+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState4
;ModbusSlave.c,148 :: 		((byte*)pCurrBlock->paryData)[bytIndex] |= bytBit;
	MOVLW       6
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        R6, 0 
	IORWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,149 :: 		} else {
	GOTO        L_ModbusSlave_coilState5
L_ModbusSlave_coilState4:
;ModbusSlave.c,151 :: 		((byte*)pCurrBlock->paryData)[bytIndex] &= (0xff ^ bytBit);
	MOVLW       6
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       255
	XORWF       R6, 0 
	MOVWF       R0 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        POSTINC0+0, 0 
	ANDWF       R0, 1 
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,152 :: 		}
L_ModbusSlave_coilState5:
;ModbusSlave.c,153 :: 		return TRUE;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_coilState
;ModbusSlave.c,154 :: 		}
L_ModbusSlave_coilState3:
;ModbusSlave.c,155 :: 		return FALSE;
	CLRF        R0 
;ModbusSlave.c,156 :: 		}
L_end_coilState:
	RETURN      0
; end of ModbusSlave_coilState

ModbusSlave_packBits:

;ModbusSlave.c,171 :: 		uint uintStart, uint uintEnd) {
;ModbusSlave.c,174 :: 		uint uintBytes = 0;
	CLRF        ModbusSlave_packBits_uintBytes_L0+0 
	CLRF        ModbusSlave_packBits_uintBytes_L0+1 
;ModbusSlave.c,176 :: 		if ( eType == COILS ) {
	MOVF        FARG_ModbusSlave_packBits_eType+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits6
;ModbusSlave.c,177 :: 		pNode = pCoils;
	MOVF        ModbusSlave_pCoils+0, 0 
	MOVWF       R8 
	MOVF        ModbusSlave_pCoils+1, 0 
	MOVWF       R9 
;ModbusSlave.c,178 :: 		} else if( eType == STATUS_INPUTS ) {
	GOTO        L_ModbusSlave_packBits7
L_ModbusSlave_packBits6:
	MOVF        FARG_ModbusSlave_packBits_eType+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits8
;ModbusSlave.c,179 :: 		pNode = pStatusBits;
	MOVF        ModbusSlave_pStatusBits+0, 0 
	MOVWF       R8 
	MOVF        ModbusSlave_pStatusBits+1, 0 
	MOVWF       R9 
;ModbusSlave.c,180 :: 		} else {
	GOTO        L_ModbusSlave_packBits9
L_ModbusSlave_packBits8:
;ModbusSlave.c,181 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
	GOTO        L_end_packBits
;ModbusSlave.c,182 :: 		}
L_ModbusSlave_packBits9:
L_ModbusSlave_packBits7:
;ModbusSlave.c,183 :: 		while( pNode != NULL ) {
L_ModbusSlave_packBits10:
	MOVLW       0
	XORWF       R9, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits201
	MOVLW       0
	XORWF       R8, 0 
L_ModbusSlave_packBits201:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits11
;ModbusSlave.c,184 :: 		if ( uintStart >= pNode->uintAddress ) {
	MOVLW       2
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits202
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+0, 0 
L_ModbusSlave_packBits202:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits12
;ModbusSlave.c,185 :: 		break;
	GOTO        L_ModbusSlave_packBits11
;ModbusSlave.c,186 :: 		}
L_ModbusSlave_packBits12:
;ModbusSlave.c,187 :: 		pNode = pNode->pNext;
	MOVLW       12
	ADDWF       R8, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
	MOVF        POSTINC0+0, 0 
	MOVWF       R9 
;ModbusSlave.c,188 :: 		}
	GOTO        L_ModbusSlave_packBits10
L_ModbusSlave_packBits11:
;ModbusSlave.c,189 :: 		if ( pNode != NULL && uintEnd < pNode->uintAddress + pNode->uintTotal ) {
	MOVLW       0
	XORWF       R9, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits203
	MOVLW       0
	XORWF       R8, 0 
L_ModbusSlave_packBits203:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits15
	MOVLW       2
	ADDWF       R8, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       R1 
	MOVLW       4
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits204
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+0, 0 
L_ModbusSlave_packBits204:
	BTFSC       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits15
L_ModbusSlave_packBits179:
;ModbusSlave.c,193 :: 		uintOffset = uintStart - pNode->uintAddress;
	MOVLW       2
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_packBits_uintStart+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R5 
	MOVF        R4, 0 
	MOVWF       R6 
;ModbusSlave.c,195 :: 		bytIndex = uintOffset / 8;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R7 
;ModbusSlave.c,197 :: 		Hi(uintOffset) = 1 << (Lo(uintOffset) & 7);
	MOVLW       7
	ANDWF       R5, 0 
	MOVWF       R0 
	MOVLW       1
	MOVWF       R6 
	MOVF        R0, 0 
L_ModbusSlave_packBits205:
	BZ          L_ModbusSlave_packBits206
	RLCF        R6, 1 
	BCF         R6, 0 
	ADDLW       255
	GOTO        L_ModbusSlave_packBits205
L_ModbusSlave_packBits206:
;ModbusSlave.c,199 :: 		Lo(uintOffset) = 1;
	MOVLW       1
	MOVWF       R5 
;ModbusSlave.c,201 :: 		*pBuffer = 0;
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	CLRF        POSTINC1+0 
;ModbusSlave.c,202 :: 		while( uintStart <= uintEnd ) {
L_ModbusSlave_packBits16:
	MOVF        FARG_ModbusSlave_packBits_uintStart+1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits207
	MOVF        FARG_ModbusSlave_packBits_uintStart+0, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+0, 0 
L_ModbusSlave_packBits207:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits17
;ModbusSlave.c,203 :: 		if ( Lo(uintOffset).B0 ) {
	BTFSS       R5, 0 
	GOTO        L_ModbusSlave_packBits18
;ModbusSlave.c,204 :: 		uintBytes++;
	INFSNZ      ModbusSlave_packBits_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packBits_uintBytes_L0+1, 1 
;ModbusSlave.c,205 :: 		}
L_ModbusSlave_packBits18:
;ModbusSlave.c,207 :: 		if ( (((byte*)pNode->paryData)[bytIndex] & Hi(uintOffset)) ) {
	MOVLW       6
	ADDWF       R8, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R7, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        R6, 0 
	ANDWF       POSTINC0+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits19
;ModbusSlave.c,208 :: 		*pBuffer |= Lo(uintOffset);
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR0
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR0H
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	MOVF        R5, 0 
	IORWF       POSTINC0+0, 1 
;ModbusSlave.c,209 :: 		}
L_ModbusSlave_packBits19:
;ModbusSlave.c,210 :: 		Hi(uintOffset) <<= 1;
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       R6 
;ModbusSlave.c,212 :: 		if ( Hi(uintOffset) == 0 ) {
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits20
;ModbusSlave.c,213 :: 		Hi(uintOffset) = 1;
	MOVLW       1
	MOVWF       R6 
;ModbusSlave.c,214 :: 		bytIndex++;
	INCF        R7, 1 
;ModbusSlave.c,215 :: 		}
L_ModbusSlave_packBits20:
;ModbusSlave.c,216 :: 		Lo(uintOffset) <<= 1;
	RLCF        R5, 1 
	BCF         R5, 0 
;ModbusSlave.c,218 :: 		if ( Lo(uintOffset) == 0 ) {
	MOVF        R5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits21
;ModbusSlave.c,219 :: 		Lo(uintOffset) = 1;
	MOVLW       1
	MOVWF       R5 
;ModbusSlave.c,220 :: 		pBuffer++;
	INFSNZ      FARG_ModbusSlave_packBits_pBuffer+0, 1 
	INCF        FARG_ModbusSlave_packBits_pBuffer+1, 1 
;ModbusSlave.c,221 :: 		*pBuffer = 0;
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	CLRF        POSTINC1+0 
;ModbusSlave.c,222 :: 		}
L_ModbusSlave_packBits21:
;ModbusSlave.c,224 :: 		uintStart++;
	INFSNZ      FARG_ModbusSlave_packBits_uintStart+0, 1 
	INCF        FARG_ModbusSlave_packBits_uintStart+1, 1 
;ModbusSlave.c,225 :: 		}
	GOTO        L_ModbusSlave_packBits16
L_ModbusSlave_packBits17:
;ModbusSlave.c,226 :: 		}
L_ModbusSlave_packBits15:
;ModbusSlave.c,227 :: 		return uintBytes;
	MOVF        ModbusSlave_packBits_uintBytes_L0+0, 0 
	MOVWF       R0 
	MOVF        ModbusSlave_packBits_uintBytes_L0+1, 0 
	MOVWF       R1 
;ModbusSlave.c,228 :: 		}
L_end_packBits:
	RETURN      0
; end of ModbusSlave_packBits

ModbusSlave_packRegisters:

;ModbusSlave.c,243 :: 		uint uintStart, uint uintEnd) {
;ModbusSlave.c,246 :: 		uint uintBytes = 0;
	CLRF        ModbusSlave_packRegisters_uintBytes_L0+0 
	CLRF        ModbusSlave_packRegisters_uintBytes_L0+1 
;ModbusSlave.c,248 :: 		if ( eType == HOLDING_REGISTERS ) {
	MOVF        FARG_ModbusSlave_packRegisters_eType+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters22
;ModbusSlave.c,249 :: 		pNode = pHoldingRegs;
	MOVF        ModbusSlave_pHoldingRegs+0, 0 
	MOVWF       R7 
	MOVF        ModbusSlave_pHoldingRegs+1, 0 
	MOVWF       R8 
;ModbusSlave.c,250 :: 		} else if( eType == INPUT_REGISTERS ) {
	GOTO        L_ModbusSlave_packRegisters23
L_ModbusSlave_packRegisters22:
	MOVF        FARG_ModbusSlave_packRegisters_eType+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters24
;ModbusSlave.c,251 :: 		pNode = pInputRegs;
	MOVF        ModbusSlave_pInputRegs+0, 0 
	MOVWF       R7 
	MOVF        ModbusSlave_pInputRegs+1, 0 
	MOVWF       R8 
;ModbusSlave.c,252 :: 		} else {
	GOTO        L_ModbusSlave_packRegisters25
L_ModbusSlave_packRegisters24:
;ModbusSlave.c,253 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
	GOTO        L_end_packRegisters
;ModbusSlave.c,254 :: 		}
L_ModbusSlave_packRegisters25:
L_ModbusSlave_packRegisters23:
;ModbusSlave.c,255 :: 		while( pNode != NULL ) {
L_ModbusSlave_packRegisters26:
	MOVLW       0
	XORWF       R8, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters209
	MOVLW       0
	XORWF       R7, 0 
L_ModbusSlave_packRegisters209:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters27
;ModbusSlave.c,256 :: 		if ( uintStart >= pNode->uintAddress ) {
	MOVLW       2
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters210
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+0, 0 
L_ModbusSlave_packRegisters210:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters28
;ModbusSlave.c,257 :: 		break;
	GOTO        L_ModbusSlave_packRegisters27
;ModbusSlave.c,258 :: 		}
L_ModbusSlave_packRegisters28:
;ModbusSlave.c,259 :: 		pNode = pNode->pNext;
	MOVLW       12
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
;ModbusSlave.c,260 :: 		}
	GOTO        L_ModbusSlave_packRegisters26
L_ModbusSlave_packRegisters27:
;ModbusSlave.c,261 :: 		if ( pNode != NULL && uintEnd < (pNode->uintAddress + pNode->uintTotal) ) {
	MOVLW       0
	XORWF       R8, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters211
	MOVLW       0
	XORWF       R7, 0 
L_ModbusSlave_packRegisters211:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters31
	MOVLW       2
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVLW       4
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters212
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+0, 0 
L_ModbusSlave_packRegisters212:
	BTFSC       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters31
L_ModbusSlave_packRegisters180:
;ModbusSlave.c,263 :: 		uintOffset = uintStart - pNode->uintAddress;
	MOVLW       2
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	MOVWF       R6 
;ModbusSlave.c,264 :: 		while( uintStart <= uintEnd ) {
L_ModbusSlave_packRegisters32:
	MOVF        FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters213
	MOVF        FARG_ModbusSlave_packRegisters_uintStart+0, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+0, 0 
L_ModbusSlave_packRegisters213:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters33
;ModbusSlave.c,265 :: 		pBuffer[uintBytes++] = Hi(((uint*)pNode->paryData)[uintOffset]);
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	ADDWF       FARG_ModbusSlave_packRegisters_pBuffer+0, 0 
	MOVWF       FSR1 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	ADDWFC      FARG_ModbusSlave_packRegisters_pBuffer+1, 0 
	MOVWF       FSR1H 
	MOVLW       6
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVLW       1
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      ModbusSlave_packRegisters_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packRegisters_uintBytes_L0+1, 1 
;ModbusSlave.c,266 :: 		pBuffer[uintBytes++] = Lo(((uint*)pNode->paryData)[uintOffset]);
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	ADDWF       FARG_ModbusSlave_packRegisters_pBuffer+0, 0 
	MOVWF       FSR1 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	ADDWFC      FARG_ModbusSlave_packRegisters_pBuffer+1, 0 
	MOVWF       FSR1H 
	MOVLW       6
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R3, 0 
	MOVWF       FSR0 
	MOVF        R1, 0 
	ADDWFC      R4, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      ModbusSlave_packRegisters_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packRegisters_uintBytes_L0+1, 1 
;ModbusSlave.c,268 :: 		uintStart++;
	INFSNZ      FARG_ModbusSlave_packRegisters_uintStart+0, 1 
	INCF        FARG_ModbusSlave_packRegisters_uintStart+1, 1 
;ModbusSlave.c,269 :: 		uintOffset++;
	INFSNZ      R5, 1 
	INCF        R6, 1 
;ModbusSlave.c,270 :: 		}
	GOTO        L_ModbusSlave_packRegisters32
L_ModbusSlave_packRegisters33:
;ModbusSlave.c,271 :: 		}
L_ModbusSlave_packRegisters31:
;ModbusSlave.c,272 :: 		return uintBytes;
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	MOVWF       R0 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	MOVWF       R1 
;ModbusSlave.c,273 :: 		}
L_end_packRegisters:
	RETURN      0
; end of ModbusSlave_packRegisters

ModbusSlave_setRegister:

;ModbusSlave.c,286 :: 		static boolean setRegister(uint uintAddress, byte bytDataHi, byte bytDataLo) {
;ModbusSlave.c,287 :: 		if ( pCurrBlock != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister215
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L_ModbusSlave_setRegister215:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister34
;ModbusSlave.c,289 :: 		Lo(uintTemp) = bytDataLo;
	MOVF        FARG_ModbusSlave_setRegister_bytDataLo+0, 0 
	MOVWF       R5 
;ModbusSlave.c,290 :: 		Hi(uintTemp) = bytDataHi;
	MOVF        FARG_ModbusSlave_setRegister_bytDataHi+0, 0 
	MOVWF       R6 
;ModbusSlave.c,291 :: 		uintOffset = uintAddress - pCurrBlock->uintAddress;
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_setRegister_uintAddress+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_setRegister_uintAddress+1, 0 
	MOVWF       R4 
;ModbusSlave.c,292 :: 		((uint*)pCurrBlock->paryData)[uintOffset] = uintTemp;
	MOVLW       6
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       FSR1 
	MOVF        R1, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       FSR1H 
	MOVF        R5, 0 
	MOVWF       POSTINC1+0 
	MOVF        R6, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,293 :: 		return TRUE;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_setRegister
;ModbusSlave.c,294 :: 		}
L_ModbusSlave_setRegister34:
;ModbusSlave.c,295 :: 		return FALSE;
	CLRF        R0 
;ModbusSlave.c,296 :: 		}
L_end_setRegister:
	RETURN      0
; end of ModbusSlave_setRegister

ModbusSlave_startTimeout:

;ModbusSlave.c,307 :: 		static void startTimeout(void) {
;ModbusSlave.c,309 :: 		TMR0ON_bit = 0;
	BCF         TMR0ON_bit+0, 7 
;ModbusSlave.c,311 :: 		if ( bytRxphase.B1 ) {
	BTFSS       ModbusSlave_bytRxphase+0, 1 
	GOTO        L_ModbusSlave_startTimeout35
;ModbusSlave.c,312 :: 		TMR0H = Hi(uintRxGapSetPt3);
	MOVF        ModbusSlave_uintRxGapSetPt3+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,313 :: 		TMR0L = Lo(uintRxGapSetPt3);
	MOVF        ModbusSlave_uintRxGapSetPt3+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,314 :: 		} else if ( bytRxphase.B2 ) {
	GOTO        L_ModbusSlave_startTimeout36
L_ModbusSlave_startTimeout35:
	BTFSS       ModbusSlave_bytRxphase+0, 2 
	GOTO        L_ModbusSlave_startTimeout37
;ModbusSlave.c,315 :: 		TMR0H = Hi(uintRxGapSetPt2);
	MOVF        ModbusSlave_uintRxGapSetPt2+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,316 :: 		TMR0L = Lo(uintRxGapSetPt2);
	MOVF        ModbusSlave_uintRxGapSetPt2+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,317 :: 		} else if ( bytRxphase.B7 ) {
	GOTO        L_ModbusSlave_startTimeout38
L_ModbusSlave_startTimeout37:
	BTFSS       ModbusSlave_bytRxphase+0, 7 
	GOTO        L_ModbusSlave_startTimeout39
;ModbusSlave.c,318 :: 		TMR0H = Hi(uintRxGapSetPt1);
	MOVF        ModbusSlave_uintRxGapSetPt1+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,319 :: 		TMR0L = Lo(uintRxGapSetPt1);
	MOVF        ModbusSlave_uintRxGapSetPt1+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,320 :: 		} else {
	GOTO        L_ModbusSlave_startTimeout40
L_ModbusSlave_startTimeout39:
;ModbusSlave.c,321 :: 		TMR0H = Hi(uintRxGapSetPt);
	MOVF        ModbusSlave_uintRxGapSetPt+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,322 :: 		TMR0L = Lo(uintRxGapSetPt);
	MOVF        ModbusSlave_uintRxGapSetPt+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,323 :: 		}
L_ModbusSlave_startTimeout40:
L_ModbusSlave_startTimeout38:
L_ModbusSlave_startTimeout36:
;ModbusSlave.c,325 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, 2 
;ModbusSlave.c,327 :: 		TMR0ON_bit = 1;
	BSF         TMR0ON_bit+0, 7 
;ModbusSlave.c,328 :: 		}
L_end_startTimeout:
	RETURN      0
; end of ModbusSlave_startTimeout

ModbusSlave_restartRx:

;ModbusSlave.c,339 :: 		static void restartRx(void) {
;ModbusSlave.c,341 :: 		bytRxphase = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,342 :: 		bytRxphase = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,344 :: 		CREN_bit = 0;
	BCF         CREN_bit+0, 4 
;ModbusSlave.c,345 :: 		CREN_bit = 1;
	BSF         CREN_bit+0, 4 
;ModbusSlave.c,347 :: 		Tx_dir = 0;
	BCF         LATE+0, 0 
;ModbusSlave.c,353 :: 		bytRxphase = 0;
	CLRF        ModbusSlave_bytRxphase+0 
;ModbusSlave.c,354 :: 		bytIndex = 0;
	CLRF        ModbusSlave_bytIndex+0 
;ModbusSlave.c,356 :: 		TXEN_bit = 0;
	BCF         TXEN_bit+0, 5 
;ModbusSlave.c,357 :: 		TXIE_bit = 0;
	BCF         TXIE_bit+0, 4 
;ModbusSlave.c,359 :: 		RCIE_bit = 1;
	BSF         RCIE_bit+0, 5 
;ModbusSlave.c,360 :: 		startTimeout();
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,361 :: 		}
L_end_restartRx:
	RETURN      0
; end of ModbusSlave_restartRx

_addModbusBlock:

;ModbusSlave.c,386 :: 		void (*pCallback)(struct _modbusBlock* pBlock)) {
;ModbusSlave.c,389 :: 		if ( bytSlaveAddress < 1 || bytSlaveAddress > 247 ) {
	MOVLW       1
	SUBWF       FARG_addModbusBlock_bytSlaveAddress+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__addModbusBlock183
	MOVF        FARG_addModbusBlock_bytSlaveAddress+0, 0 
	SUBLW       247
	BTFSS       STATUS+0, 0 
	GOTO        L__addModbusBlock183
	GOTO        L_addModbusBlock43
L__addModbusBlock183:
;ModbusSlave.c,390 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,391 :: 		}
L_addModbusBlock43:
;ModbusSlave.c,394 :: 		|| uintAddress == 0
	MOVLW       0
	XORWF       FARG_addModbusBlock_pBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock219
	MOVLW       0
	XORWF       FARG_addModbusBlock_pBlock+0, 0 
L__addModbusBlock219:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock182
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintAddress+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock220
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintAddress+0, 0 
L__addModbusBlock220:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock182
;ModbusSlave.c,395 :: 		|| uintTotal == 0
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintTotal+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock221
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintTotal+0, 0 
L__addModbusBlock221:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock182
;ModbusSlave.c,396 :: 		|| paryData == NULL ) {
	MOVLW       0
	XORWF       FARG_addModbusBlock_paryData+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock222
	MOVLW       0
	XORWF       FARG_addModbusBlock_paryData+0, 0 
L__addModbusBlock222:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock182
	GOTO        L_addModbusBlock46
L__addModbusBlock182:
;ModbusSlave.c,397 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,398 :: 		}
L_addModbusBlock46:
;ModbusSlave.c,399 :: 		if ( eType == COILS ) {
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock47
;ModbusSlave.c,400 :: 		pLL   = &pCoils;
	MOVLW       ModbusSlave_pCoils+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pCoils+0)
	MOVWF       R7 
;ModbusSlave.c,401 :: 		} else if ( eType == STATUS_INPUTS ) {
	GOTO        L_addModbusBlock48
L_addModbusBlock47:
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock49
;ModbusSlave.c,402 :: 		pLL   = &pStatusBits;
	MOVLW       ModbusSlave_pStatusBits+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pStatusBits+0)
	MOVWF       R7 
;ModbusSlave.c,403 :: 		} else if ( eType == HOLDING_REGISTERS ) {
	GOTO        L_addModbusBlock50
L_addModbusBlock49:
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock51
;ModbusSlave.c,404 :: 		pLL   = &pHoldingRegs;
	MOVLW       ModbusSlave_pHoldingRegs+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pHoldingRegs+0)
	MOVWF       R7 
;ModbusSlave.c,405 :: 		} else if ( eType == INPUT_REGISTERS ) {
	GOTO        L_addModbusBlock52
L_addModbusBlock51:
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock53
;ModbusSlave.c,406 :: 		pLL   = &pInputRegs;
	MOVLW       ModbusSlave_pInputRegs+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pInputRegs+0)
	MOVWF       R7 
;ModbusSlave.c,407 :: 		} else {
	GOTO        L_addModbusBlock54
L_addModbusBlock53:
;ModbusSlave.c,408 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,409 :: 		}
L_addModbusBlock54:
L_addModbusBlock52:
L_addModbusBlock50:
L_addModbusBlock48:
;ModbusSlave.c,410 :: 		if ( *pLL == NULL ) {
	MOVFF       R6, FSR0
	MOVFF       R7, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       0
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock223
	MOVLW       0
	XORWF       R1, 0 
L__addModbusBlock223:
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock55
;ModbusSlave.c,412 :: 		*pLL = pBlock;
	MOVFF       R6, FSR1
	MOVFF       R7, FSR1H
	MOVF        FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,413 :: 		} else {
	GOTO        L_addModbusBlock56
L_addModbusBlock55:
;ModbusSlave.c,416 :: 		for( pNode=*pLL; pNode->pNext!=NULL; pNode=pNode->pNext ) {
	MOVFF       R6, FSR0
	MOVFF       R7, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
L_addModbusBlock57:
	MOVLW       12
	ADDWF       R4, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       0
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock224
	MOVLW       0
	XORWF       R1, 0 
L__addModbusBlock224:
	BTFSC       STATUS+0, 2 
	GOTO        L_addModbusBlock58
;ModbusSlave.c,417 :: 		if ( uintAddress >= pNode->uintAddress
	MOVLW       2
	ADDWF       R4, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
;ModbusSlave.c,418 :: 		&& uintAddress <= (pNode->uintAddress + pNode->uintTotal - 1)  ) {
	MOVF        R2, 0 
	SUBWF       FARG_addModbusBlock_uintAddress+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock225
	MOVF        R1, 0 
	SUBWF       FARG_addModbusBlock_uintAddress+0, 0 
L__addModbusBlock225:
	BTFSS       STATUS+0, 0 
	GOTO        L_addModbusBlock62
	MOVLW       2
	ADDWF       R4, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR0H 
	MOVLW       4
	ADDWF       R4, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        FARG_addModbusBlock_uintAddress+1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock226
	MOVF        FARG_addModbusBlock_uintAddress+0, 0 
	SUBWF       R2, 0 
L__addModbusBlock226:
	BTFSS       STATUS+0, 0 
	GOTO        L_addModbusBlock62
L__addModbusBlock181:
;ModbusSlave.c,420 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,421 :: 		}
L_addModbusBlock62:
;ModbusSlave.c,416 :: 		for( pNode=*pLL; pNode->pNext!=NULL; pNode=pNode->pNext ) {
	MOVLW       12
	ADDWF       R4, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
;ModbusSlave.c,422 :: 		}
	GOTO        L_addModbusBlock57
L_addModbusBlock58:
;ModbusSlave.c,424 :: 		pNode->pNext = pBlock;
	MOVLW       12
	ADDWF       R4, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,425 :: 		}
L_addModbusBlock56:
;ModbusSlave.c,427 :: 		pBlock->bytSlaveAddress = bytSlaveAddress;
	MOVFF       FARG_addModbusBlock_pBlock+0, FSR1
	MOVFF       FARG_addModbusBlock_pBlock+1, FSR1H
	MOVF        FARG_addModbusBlock_bytSlaveAddress+0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,428 :: 		pBlock->eType           = eType;
	MOVLW       1
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_eType+0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,429 :: 		pBlock->uintAddress     = uintAddress;
	MOVLW       2
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_uintAddress+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_uintAddress+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,430 :: 		pBlock->uintTotal       = uintTotal;
	MOVLW       4
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_uintTotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_uintTotal+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,431 :: 		pBlock->paryData        = paryData;
	MOVLW       6
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_paryData+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_paryData+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,432 :: 		pBlock->pCallback       = pCallback;
	MOVLW       8
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_pCallback+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pCallback+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pCallback+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pCallback+3, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,433 :: 		pBlock->pNext           = NULL;
	MOVLW       12
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;ModbusSlave.c,434 :: 		}
L_end_addModbusBlock:
	RETURN      0
; end of _addModbusBlock

_decodePacket:

;ModbusSlave.c,447 :: 		void decodePacket(void) {
;ModbusSlave.c,450 :: 		if ( TMR0IF_bit ) {
	BTFSS       TMR0IF_bit+0, 2 
	GOTO        L_decodePacket63
;ModbusSlave.c,451 :: 		bytRxphase.B0 = 1;
	BSF         ModbusSlave_bytRxphase+0, 0 
;ModbusSlave.c,452 :: 		TMR0ON_bit = 0;
	BCF         TMR0ON_bit+0, 7 
;ModbusSlave.c,454 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, 2 
;ModbusSlave.c,456 :: 		if ( bytRxphase.B7 ) {
	BTFSS       ModbusSlave_bytRxphase+0, 7 
	GOTO        L_decodePacket64
;ModbusSlave.c,458 :: 		restartRx();
	CALL        ModbusSlave_restartRx+0, 0
;ModbusSlave.c,459 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,460 :: 		}
L_decodePacket64:
;ModbusSlave.c,461 :: 		}
L_decodePacket63:
;ModbusSlave.c,462 :: 		if( RCIF_bit ) {
	BTFSS       RCIF_bit+0, 5 
	GOTO        L_decodePacket65
;ModbusSlave.c,465 :: 		if ( OERR_bit || FERR_bit ) {
	BTFSC       OERR_bit+0, 1 
	GOTO        L__decodePacket193
	BTFSC       FERR_bit+0, 2 
	GOTO        L__decodePacket193
	GOTO        L_decodePacket68
L__decodePacket193:
;ModbusSlave.c,466 :: 		restartRx();
	CALL        ModbusSlave_restartRx+0, 0
;ModbusSlave.c,467 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,468 :: 		}
L_decodePacket68:
;ModbusSlave.c,471 :: 		bytTemp = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       decodePacket_bytTemp_L1+0 
;ModbusSlave.c,474 :: 		if ( bytRxphase == 0 || bytRxphase.B2 == 1 ||
	MOVF        ModbusSlave_bytRxphase+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket192
	BTFSC       ModbusSlave_bytRxphase+0, 2 
	GOTO        L__decodePacket192
;ModbusSlave.c,475 :: 		bytIndex >= MAX_PACKET_LENGTH ) {
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORLW       1
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket228
	MOVLW       0
	SUBWF       ModbusSlave_bytIndex+0, 0 
L__decodePacket228:
	BTFSC       STATUS+0, 0 
	GOTO        L__decodePacket192
	GOTO        L_decodePacket71
L__decodePacket192:
;ModbusSlave.c,477 :: 		bytIndex = 0;
	CLRF        ModbusSlave_bytIndex+0 
;ModbusSlave.c,478 :: 		bytRxphase = 0;
	CLRF        ModbusSlave_bytRxphase+0 
;ModbusSlave.c,479 :: 		startTimeout();  // 4.5 chars
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,480 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,481 :: 		}
L_decodePacket71:
;ModbusSlave.c,482 :: 		if ( bytIndex == 0) {
	MOVF        ModbusSlave_bytIndex+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket72
;ModbusSlave.c,484 :: 		bytRxphase = 2;
	MOVLW       2
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,485 :: 		}
L_decodePacket72:
;ModbusSlave.c,487 :: 		aryBuffer[bytIndex++] = bytTemp;
	MOVLW       ModbusSlave_aryBuffer+0
	MOVWF       FSR1 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	MOVWF       FSR1H 
	MOVF        ModbusSlave_bytIndex+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        decodePacket_bytTemp_L1+0, 0 
	MOVWF       POSTINC1+0 
	INCF        ModbusSlave_bytIndex+0, 1 
;ModbusSlave.c,489 :: 		startTimeout();  // 2.5 chars
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,490 :: 		} else if ( bytRxphase.B7 ) {
	GOTO        L_decodePacket73
L_decodePacket65:
	BTFSS       ModbusSlave_bytRxphase+0, 7 
	GOTO        L_decodePacket74
;ModbusSlave.c,491 :: 		if ( TXIF_bit ) {
	BTFSS       TXIF_bit+0, 4 
	GOTO        L_decodePacket75
;ModbusSlave.c,492 :: 		if ( bytIndex < aryBuffer[0] ) {
	MOVF        ModbusSlave_aryBuffer+0, 0 
	SUBWF       ModbusSlave_bytIndex+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket76
;ModbusSlave.c,493 :: 		TXREG=aryBuffer[bytIndex++];
	MOVLW       ModbusSlave_aryBuffer+0
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	MOVWF       FSR0H 
	MOVF        ModbusSlave_bytIndex+0, 0 
	ADDWF       FSR0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       TXREG+0 
	INCF        ModbusSlave_bytIndex+0, 1 
;ModbusSlave.c,494 :: 		} else {
	GOTO        L_decodePacket77
L_decodePacket76:
;ModbusSlave.c,496 :: 		startTimeout();  // 1 char
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,498 :: 		TXIE_bit = 0;
	BCF         TXIE_bit+0, 4 
;ModbusSlave.c,499 :: 		}
L_decodePacket77:
;ModbusSlave.c,500 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,501 :: 		}
L_decodePacket75:
;ModbusSlave.c,502 :: 		}
L_decodePacket74:
L_decodePacket73:
;ModbusSlave.c,503 :: 		if ( bytRxphase == 3 ) {
	MOVF        ModbusSlave_bytRxphase+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket78
;ModbusSlave.c,505 :: 		bytRxphase = 4;
	MOVLW       4
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,506 :: 		startTimeout(); // 2 chars
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,507 :: 		}
L_decodePacket78:
;ModbusSlave.c,508 :: 		if ( bytRxphase != 5 ) {
	MOVF        ModbusSlave_bytRxphase+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket79
;ModbusSlave.c,510 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,511 :: 		}
L_decodePacket79:
;ModbusSlave.c,512 :: 		if ( bytSlaveAddress != aryBuffer[0] ) {
	MOVF        ModbusSlave_bytSlaveAddress+0, 0 
	XORWF       ModbusSlave_aryBuffer+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket80
;ModbusSlave.c,514 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,515 :: 		}
L_decodePacket80:
;ModbusSlave.c,517 :: 		uintCRCpos = 6;
	MOVLW       6
	MOVWF       decodePacket_uintCRCpos_L0+0 
	MOVLW       0
	MOVWF       decodePacket_uintCRCpos_L0+1 
;ModbusSlave.c,519 :: 		pCurrBlock = NULL;
	CLRF        ModbusSlave_pCurrBlock+0 
	CLRF        ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,522 :: 		aryBuffer[1] == PRESET_MULTIPLE_REGISTERS )  {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket191
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket191
	GOTO        L_decodePacket83
L__decodePacket191:
;ModbusSlave.c,523 :: 		uintCRCpos += 1 + aryBuffer[6];
	MOVF        ModbusSlave_aryBuffer+6, 0 
	ADDLW       1
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	ADDWF       decodePacket_uintCRCpos_L0+0, 1 
	MOVF        R1, 0 
	ADDWFC      decodePacket_uintCRCpos_L0+1, 1 
;ModbusSlave.c,524 :: 		}
L_decodePacket83:
;ModbusSlave.c,526 :: 		uintCRC = calcCRC(uintCRCpos);
	MOVF        decodePacket_uintCRCpos_L0+0, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+0 
	MOVF        decodePacket_uintCRCpos_L0+1, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+1 
	CALL        ModbusSlave_calcCRC+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_uintCRC_L0+0 
	MOVF        R1, 0 
	MOVWF       decodePacket_uintCRC_L0+1 
;ModbusSlave.c,528 :: 		if ( Lo(uintCRC)  == aryBuffer[uintCRCpos] &&
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       decodePacket_uintCRCpos_L0+0, 0 
	MOVWF       FSR2 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      decodePacket_uintCRCpos_L0+1, 0 
	MOVWF       FSR2H 
;ModbusSlave.c,529 :: 		Hi(uintCRC) == aryBuffer[uintCRCpos + 1] ) {
	MOVF        decodePacket_uintCRC_L0+0, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket86
	MOVLW       1
	ADDWF       decodePacket_uintCRCpos_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintCRCpos_L0+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR2 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR2H 
	MOVF        decodePacket_uintCRC_L0+1, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket86
L__decodePacket190:
;ModbusSlave.c,531 :: 		uint uintLength = 6;
	MOVLW       6
	MOVWF       decodePacket_uintLength_L1+0 
	MOVLW       0
	MOVWF       decodePacket_uintLength_L1+1 
;ModbusSlave.c,533 :: 		switch( aryBuffer[1] ) {
	GOTO        L_decodePacket87
;ModbusSlave.c,534 :: 		case READ_COILS:
L_decodePacket89:
;ModbusSlave.c,535 :: 		case FORCE_SINGLE_COIL:
L_decodePacket90:
;ModbusSlave.c,536 :: 		case FORCE_MULTIPLE_COILS:
L_decodePacket91:
;ModbusSlave.c,537 :: 		if ( pCoils == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCoils+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket229
	MOVLW       0
	XORWF       ModbusSlave_pCoils+0, 0 
L__decodePacket229:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket92
;ModbusSlave.c,539 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,540 :: 		} else {
	GOTO        L_decodePacket93
L_decodePacket92:
;ModbusSlave.c,541 :: 		pCurrBlock = pCoils;
	MOVF        ModbusSlave_pCoils+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        ModbusSlave_pCoils+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,542 :: 		}
L_decodePacket93:
;ModbusSlave.c,543 :: 		break;
	GOTO        L_decodePacket88
;ModbusSlave.c,544 :: 		case READ_STATUS_INPUTS:
L_decodePacket94:
;ModbusSlave.c,545 :: 		if ( pStatusBits == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pStatusBits+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket230
	MOVLW       0
	XORWF       ModbusSlave_pStatusBits+0, 0 
L__decodePacket230:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket95
;ModbusSlave.c,547 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,548 :: 		} else {
	GOTO        L_decodePacket96
L_decodePacket95:
;ModbusSlave.c,549 :: 		pCurrBlock = pStatusBits;
	MOVF        ModbusSlave_pStatusBits+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        ModbusSlave_pStatusBits+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,550 :: 		}
L_decodePacket96:
;ModbusSlave.c,551 :: 		break;
	GOTO        L_decodePacket88
;ModbusSlave.c,552 :: 		case READ_HOLDING_REGISTERS:
L_decodePacket97:
;ModbusSlave.c,553 :: 		case PRESET_SINGLE_REGISTER:
L_decodePacket98:
;ModbusSlave.c,554 :: 		case PRESET_MULTIPLE_REGISTERS:
L_decodePacket99:
;ModbusSlave.c,555 :: 		if ( pHoldingRegs == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pHoldingRegs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket231
	MOVLW       0
	XORWF       ModbusSlave_pHoldingRegs+0, 0 
L__decodePacket231:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket100
;ModbusSlave.c,557 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,558 :: 		} else {
	GOTO        L_decodePacket101
L_decodePacket100:
;ModbusSlave.c,559 :: 		pCurrBlock = pHoldingRegs;
	MOVF        ModbusSlave_pHoldingRegs+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        ModbusSlave_pHoldingRegs+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,560 :: 		}
L_decodePacket101:
;ModbusSlave.c,561 :: 		break;
	GOTO        L_decodePacket88
;ModbusSlave.c,562 :: 		case READ_INPUT_REGISTERS:
L_decodePacket102:
;ModbusSlave.c,563 :: 		if ( pInputRegs == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pInputRegs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket232
	MOVLW       0
	XORWF       ModbusSlave_pInputRegs+0, 0 
L__decodePacket232:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket103
;ModbusSlave.c,565 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,566 :: 		} else {
	GOTO        L_decodePacket104
L_decodePacket103:
;ModbusSlave.c,567 :: 		pCurrBlock = pInputRegs;
	MOVF        ModbusSlave_pInputRegs+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        ModbusSlave_pInputRegs+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,568 :: 		}
L_decodePacket104:
;ModbusSlave.c,569 :: 		break;
	GOTO        L_decodePacket88
;ModbusSlave.c,570 :: 		default:
L_decodePacket105:
;ModbusSlave.c,572 :: 		exceptionCode = ILLEGAL_FUNCTION;
	MOVLW       1
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,573 :: 		break;
	GOTO        L_decodePacket88
;ModbusSlave.c,574 :: 		}
L_decodePacket87:
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket89
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket90
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket91
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket94
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket97
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket98
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket99
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket102
	GOTO        L_decodePacket105
L_decodePacket88:
;ModbusSlave.c,575 :: 		if( exceptionCode == NO_EXCEPTION ) {
	MOVF        ModbusSlave_exceptionCode+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket106
;ModbusSlave.c,582 :: 		Lo(uintSAddr) = aryBuffer[3];
	MOVF        ModbusSlave_aryBuffer+3, 0 
	MOVWF       decodePacket_uintSAddr_L2+0 
;ModbusSlave.c,583 :: 		Hi(uintSAddr) = aryBuffer[2];
	MOVF        ModbusSlave_aryBuffer+2, 0 
	MOVWF       decodePacket_uintSAddr_L2+1 
;ModbusSlave.c,585 :: 		Lo(uintItemCount) = aryBuffer[5];
	MOVF        ModbusSlave_aryBuffer+5, 0 
	MOVWF       decodePacket_uintItemCount_L2+0 
;ModbusSlave.c,586 :: 		Hi(uintItemCount) = aryBuffer[4];
	MOVF        ModbusSlave_aryBuffer+4, 0 
	MOVWF       decodePacket_uintItemCount_L2+1 
;ModbusSlave.c,588 :: 		uintEAddr = uintSAddr + uintItemCount;
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	ADDWF       decodePacket_uintSAddr_L2+0, 0 
	MOVWF       decodePacket_uintEAddr_L2+0 
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	ADDWFC      decodePacket_uintSAddr_L2+1, 0 
	MOVWF       decodePacket_uintEAddr_L2+1 
;ModbusSlave.c,589 :: 		uintSAddr++;
	INFSNZ      decodePacket_uintSAddr_L2+0, 1 
	INCF        decodePacket_uintSAddr_L2+1, 1 
;ModbusSlave.c,591 :: 		while( pCurrBlock != NULL ) {
L_decodePacket107:
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket233
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L__decodePacket233:
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket108
;ModbusSlave.c,592 :: 		if ( uintSAddr >= pCurrBlock->uintAddress
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
;ModbusSlave.c,594 :: 		pCurrBlock->uintTotal - 1)  ) {
	MOVF        R2, 0 
	SUBWF       decodePacket_uintSAddr_L2+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket234
	MOVF        R1, 0 
	SUBWF       decodePacket_uintSAddr_L2+0, 0 
L__decodePacket234:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket111
;ModbusSlave.c,593 :: 		&& uintSAddr <= (pCurrBlock->uintAddress +
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
;ModbusSlave.c,594 :: 		pCurrBlock->uintTotal - 1)  ) {
	MOVLW       4
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket235
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	SUBWF       R2, 0 
L__decodePacket235:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket111
L__decodePacket189:
;ModbusSlave.c,595 :: 		break;
	GOTO        L_decodePacket108
;ModbusSlave.c,596 :: 		}
L_decodePacket111:
;ModbusSlave.c,597 :: 		pCurrBlock = pCurrBlock->pNext;
	MOVLW       12
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,598 :: 		}
	GOTO        L_decodePacket107
L_decodePacket108:
;ModbusSlave.c,600 :: 		switch( aryBuffer[1] ) {
	GOTO        L_decodePacket112
;ModbusSlave.c,601 :: 		case READ_COILS:
L_decodePacket114:
;ModbusSlave.c,602 :: 		case READ_STATUS_INPUTS:
L_decodePacket115:
;ModbusSlave.c,603 :: 		if ( aryBuffer[1] == READ_COILS ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket116
;ModbusSlave.c,604 :: 		eType = COILS;
	MOVLW       1
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,605 :: 		} else {
	GOTO        L_decodePacket117
L_decodePacket116:
;ModbusSlave.c,606 :: 		eType = STATUS_INPUTS;
	MOVLW       2
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,607 :: 		}
L_decodePacket117:
;ModbusSlave.c,608 :: 		aryBuffer[2] = packBits(eType, &aryBuffer[3], uintSAddr, uintEAddr);
	MOVF        decodePacket_eType_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_eType+0 
	MOVLW       ModbusSlave_aryBuffer+3
	MOVWF       FARG_ModbusSlave_packBits_pBuffer+0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+3)
	MOVWF       FARG_ModbusSlave_packBits_pBuffer+1 
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintStart+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintStart+1 
	MOVF        decodePacket_uintEAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintEnd+0 
	MOVF        decodePacket_uintEAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintEnd+1 
	CALL        ModbusSlave_packBits+0, 0
	MOVF        R0, 0 
	MOVWF       ModbusSlave_aryBuffer+2 
;ModbusSlave.c,610 :: 		if ( aryBuffer[2] == 0 ) {
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket118
;ModbusSlave.c,612 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,613 :: 		} else {
	GOTO        L_decodePacket119
L_decodePacket118:
;ModbusSlave.c,614 :: 		uintLength = aryBuffer[2] + 3;
	MOVLW       3
	ADDWF       ModbusSlave_aryBuffer+2, 0 
	MOVWF       decodePacket_uintLength_L1+0 
	CLRF        decodePacket_uintLength_L1+1 
	MOVLW       0
	ADDWFC      decodePacket_uintLength_L1+1, 1 
;ModbusSlave.c,615 :: 		}
L_decodePacket119:
;ModbusSlave.c,616 :: 		break;
	GOTO        L_decodePacket113
;ModbusSlave.c,617 :: 		case READ_HOLDING_REGISTERS:
L_decodePacket120:
;ModbusSlave.c,618 :: 		case READ_INPUT_REGISTERS:
L_decodePacket121:
;ModbusSlave.c,619 :: 		if ( aryBuffer[1] == READ_INPUT_REGISTERS ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket122
;ModbusSlave.c,620 :: 		eType = INPUT_REGISTERS;
	MOVLW       4
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,621 :: 		} else {
	GOTO        L_decodePacket123
L_decodePacket122:
;ModbusSlave.c,622 :: 		eType = HOLDING_REGISTERS;
	MOVLW       3
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,623 :: 		}
L_decodePacket123:
;ModbusSlave.c,624 :: 		aryBuffer[2] = packRegisters(eType, &aryBuffer[3],
	MOVF        decodePacket_eType_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_eType+0 
	MOVLW       ModbusSlave_aryBuffer+3
	MOVWF       FARG_ModbusSlave_packRegisters_pBuffer+0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+3)
	MOVWF       FARG_ModbusSlave_packRegisters_pBuffer+1 
;ModbusSlave.c,625 :: 		uintSAddr, uintEAddr);
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintStart+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintStart+1 
	MOVF        decodePacket_uintEAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintEnd+0 
	MOVF        decodePacket_uintEAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintEnd+1 
	CALL        ModbusSlave_packRegisters+0, 0
	MOVF        R0, 0 
	MOVWF       ModbusSlave_aryBuffer+2 
;ModbusSlave.c,627 :: 		if ( aryBuffer[2] == 0 ) {
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket124
;ModbusSlave.c,629 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,630 :: 		} else {
	GOTO        L_decodePacket125
L_decodePacket124:
;ModbusSlave.c,631 :: 		uintLength = aryBuffer[2] + 3;
	MOVLW       3
	ADDWF       ModbusSlave_aryBuffer+2, 0 
	MOVWF       decodePacket_uintLength_L1+0 
	CLRF        decodePacket_uintLength_L1+1 
	MOVLW       0
	ADDWFC      decodePacket_uintLength_L1+1, 1 
;ModbusSlave.c,632 :: 		}
L_decodePacket125:
;ModbusSlave.c,633 :: 		break;
	GOTO        L_decodePacket113
;ModbusSlave.c,634 :: 		case FORCE_SINGLE_COIL:
L_decodePacket126:
;ModbusSlave.c,635 :: 		if ( aryBuffer[4] == 0xff && aryBuffer[5] == 0x0 ) {
	MOVF        ModbusSlave_aryBuffer+4, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket129
	MOVF        ModbusSlave_aryBuffer+5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket129
L__decodePacket188:
;ModbusSlave.c,637 :: 		blnState = coilState(uintSAddr, TRUE);
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	MOVLW       1
	MOVWF       FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_blnState_L2+0 
;ModbusSlave.c,638 :: 		} else if ( aryBuffer[4] == 0x0 && aryBuffer[5] == 0x0 ) {
	GOTO        L_decodePacket130
L_decodePacket129:
	MOVF        ModbusSlave_aryBuffer+4, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket133
	MOVF        ModbusSlave_aryBuffer+5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket133
L__decodePacket187:
;ModbusSlave.c,640 :: 		blnState = coilState(uintSAddr, FALSE);
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	CLRF        FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_blnState_L2+0 
;ModbusSlave.c,641 :: 		}
L_decodePacket133:
L_decodePacket130:
;ModbusSlave.c,642 :: 		if ( blnState == FALSE ) {
	MOVF        decodePacket_blnState_L2+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket134
;ModbusSlave.c,644 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,645 :: 		}
L_decodePacket134:
;ModbusSlave.c,646 :: 		break;
	GOTO        L_decodePacket113
;ModbusSlave.c,647 :: 		case PRESET_SINGLE_REGISTER:
L_decodePacket135:
;ModbusSlave.c,648 :: 		if ( setRegister(uintSAddr, aryBuffer[4], aryBuffer[5]) == FALSE ) {
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+1 
	MOVF        ModbusSlave_aryBuffer+4, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataHi+0 
	MOVF        ModbusSlave_aryBuffer+5, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataLo+0 
	CALL        ModbusSlave_setRegister+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket136
;ModbusSlave.c,650 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,651 :: 		}
L_decodePacket136:
;ModbusSlave.c,652 :: 		break;
	GOTO        L_decodePacket113
;ModbusSlave.c,653 :: 		case FORCE_MULTIPLE_COILS:
L_decodePacket137:
;ModbusSlave.c,655 :: 		uintItemCount > (aryBuffer[6] * 8) ) {
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	SUBLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket236
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	SUBLW       176
L__decodePacket236:
	BTFSS       STATUS+0, 0 
	GOTO        L__decodePacket186
	MOVLW       3
	MOVWF       R0 
	MOVF        ModbusSlave_aryBuffer+6, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVF        R0, 0 
L__decodePacket237:
	BZ          L__decodePacket238
	RLCF        R1, 1 
	BCF         R1, 0 
	RLCF        R2, 1 
	ADDLW       255
	GOTO        L__decodePacket237
L__decodePacket238:
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket239
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	SUBWF       R1, 0 
L__decodePacket239:
	BTFSS       STATUS+0, 0 
	GOTO        L__decodePacket186
	GOTO        L_decodePacket140
L__decodePacket186:
;ModbusSlave.c,657 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,658 :: 		break;
	GOTO        L_decodePacket113
;ModbusSlave.c,659 :: 		}
L_decodePacket140:
;ModbusSlave.c,660 :: 		case PRESET_MULTIPLE_REGISTERS:
L_decodePacket141:
;ModbusSlave.c,662 :: 		uintItemCount > MAX_REGISTERS_IN_FC16) ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket144
	MOVLW       0
	MOVWF       R0 
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket240
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	SUBLW       123
L__decodePacket240:
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket144
L__decodePacket185:
;ModbusSlave.c,664 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,665 :: 		} else {
	GOTO        L_decodePacket145
L_decodePacket144:
;ModbusSlave.c,666 :: 		bytBit = 1;
	MOVLW       1
	MOVWF       decodePacket_bytBit_L2+0 
;ModbusSlave.c,667 :: 		uintOffset = 0;
	CLRF        decodePacket_uintOffset_L2+0 
	CLRF        decodePacket_uintOffset_L2+1 
;ModbusSlave.c,668 :: 		uintAddr = uintSAddr;
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       decodePacket_uintAddr_L2+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       decodePacket_uintAddr_L2+1 
;ModbusSlave.c,670 :: 		while( uintAddr <= uintEAddr ) {
L_decodePacket146:
	MOVF        decodePacket_uintAddr_L2+1, 0 
	SUBWF       decodePacket_uintEAddr_L2+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket241
	MOVF        decodePacket_uintAddr_L2+0, 0 
	SUBWF       decodePacket_uintEAddr_L2+0, 0 
L__decodePacket241:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket147
;ModbusSlave.c,671 :: 		if ( aryBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket148
;ModbusSlave.c,672 :: 		if ( setRegister(uintAddr,
	MOVF        decodePacket_uintAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+0 
	MOVF        decodePacket_uintAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+1 
;ModbusSlave.c,673 :: 		aryBuffer[7 + uintOffset],
	MOVLW       7
	ADDWF       decodePacket_uintOffset_L2+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataHi+0 
;ModbusSlave.c,674 :: 		aryBuffer[8 + uintOffset]) == FALSE ) {
	MOVLW       8
	ADDWF       decodePacket_uintOffset_L2+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataLo+0 
	CALL        ModbusSlave_setRegister+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket149
;ModbusSlave.c,675 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,676 :: 		break;
	GOTO        L_decodePacket147
;ModbusSlave.c,677 :: 		}
L_decodePacket149:
;ModbusSlave.c,678 :: 		uintOffset += 2;
	MOVLW       2
	ADDWF       decodePacket_uintOffset_L2+0, 1 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 1 
;ModbusSlave.c,679 :: 		uintAddr++;
	INFSNZ      decodePacket_uintAddr_L2+0, 1 
	INCF        decodePacket_uintAddr_L2+1, 1 
;ModbusSlave.c,680 :: 		} else {
	GOTO        L_decodePacket150
L_decodePacket148:
;ModbusSlave.c,681 :: 		blnState = FALSE;
	CLRF        decodePacket_blnState_L2+0 
;ModbusSlave.c,682 :: 		if ( (aryBuffer[7 + uintOffset] & bytBit) > 0 ) {
	MOVLW       7
	ADDWF       decodePacket_uintOffset_L2+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        decodePacket_bytBit_L2+0, 0 
	ANDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket151
;ModbusSlave.c,683 :: 		blnState = TRUE;
	MOVLW       1
	MOVWF       decodePacket_blnState_L2+0 
;ModbusSlave.c,684 :: 		}
L_decodePacket151:
;ModbusSlave.c,685 :: 		if ( coilState(uintAddr, blnState) == FALSE ) {
	MOVF        decodePacket_uintAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	MOVF        decodePacket_blnState_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket152
;ModbusSlave.c,686 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,687 :: 		break;
	GOTO        L_decodePacket147
;ModbusSlave.c,688 :: 		}
L_decodePacket152:
;ModbusSlave.c,689 :: 		bytBit <<= 1;
	MOVF        decodePacket_bytBit_L2+0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       decodePacket_bytBit_L2+0 
;ModbusSlave.c,690 :: 		if ( bytBit == 0 ) {
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket153
;ModbusSlave.c,691 :: 		bytBit = 1;
	MOVLW       1
	MOVWF       decodePacket_bytBit_L2+0 
;ModbusSlave.c,692 :: 		uintOffset++;
	INFSNZ      decodePacket_uintOffset_L2+0, 1 
	INCF        decodePacket_uintOffset_L2+1, 1 
;ModbusSlave.c,693 :: 		}
L_decodePacket153:
;ModbusSlave.c,694 :: 		uintAddr++;
	INFSNZ      decodePacket_uintAddr_L2+0, 1 
	INCF        decodePacket_uintAddr_L2+1, 1 
;ModbusSlave.c,695 :: 		}
L_decodePacket150:
;ModbusSlave.c,696 :: 		}
	GOTO        L_decodePacket146
L_decodePacket147:
;ModbusSlave.c,697 :: 		}
L_decodePacket145:
;ModbusSlave.c,698 :: 		break;
	GOTO        L_decodePacket113
;ModbusSlave.c,699 :: 		}
L_decodePacket112:
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket114
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket115
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket120
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket121
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket126
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket135
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket137
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket141
L_decodePacket113:
;ModbusSlave.c,700 :: 		}
L_decodePacket106:
;ModbusSlave.c,701 :: 		if( exceptionCode != NO_EXCEPTION ) {
	MOVF        ModbusSlave_exceptionCode+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket154
;ModbusSlave.c,702 :: 		aryBuffer[1] |= EXCEPTION_FLAG;
	BSF         ModbusSlave_aryBuffer+1, 7 
;ModbusSlave.c,703 :: 		aryBuffer[2] = (byte)exceptionCode;
	MOVF        ModbusSlave_exceptionCode+0, 0 
	MOVWF       ModbusSlave_aryBuffer+2 
;ModbusSlave.c,704 :: 		exceptionCode = NO_EXCEPTION;
	CLRF        ModbusSlave_exceptionCode+0 
;ModbusSlave.c,705 :: 		uintLength = 3;
	MOVLW       3
	MOVWF       decodePacket_uintLength_L1+0 
	MOVLW       0
	MOVWF       decodePacket_uintLength_L1+1 
;ModbusSlave.c,706 :: 		}
L_decodePacket154:
;ModbusSlave.c,707 :: 		if ( uintLength > 0 ) {
	MOVLW       0
	MOVWF       R0 
	MOVF        decodePacket_uintLength_L1+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket242
	MOVF        decodePacket_uintLength_L1+0, 0 
	SUBLW       0
L__decodePacket242:
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket155
;ModbusSlave.c,709 :: 		if ( pCurrBlock != NULL && pCurrBlock->pCallback != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket243
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L__decodePacket243:
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket158
	MOVLW       8
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R0 
	XORWF       R4, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket244
	MOVF        R0, 0 
	XORWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket244
	MOVF        R0, 0 
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket244
	MOVF        R1, 0 
	XORLW       0
L__decodePacket244:
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket158
L__decodePacket184:
;ModbusSlave.c,710 :: 		(*pCurrBlock->pCallback)(pCurrBlock);
	MOVLW       8
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       FSR1 
	MOVF        R3, 0 
	MOVWF       FSR1H 
	MOVF        ModbusSlave_pCurrBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        ModbusSlave_pCurrBlock+1, 0 
	MOVWF       POSTINC1+0 
	CALL        _____DoIFC+0, 0
;ModbusSlave.c,711 :: 		}
L_decodePacket158:
;ModbusSlave.c,713 :: 		uintCRC = calcCRC(uintLength);
	MOVF        decodePacket_uintLength_L1+0, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+0 
	MOVF        decodePacket_uintLength_L1+1, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+1 
	CALL        ModbusSlave_calcCRC+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_uintCRC_L0+0 
	MOVF        R1, 0 
	MOVWF       decodePacket_uintCRC_L0+1 
;ModbusSlave.c,714 :: 		aryBuffer[uintLength++] = Lo(uintCRC);
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       decodePacket_uintLength_L1+0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      decodePacket_uintLength_L1+1, 0 
	MOVWF       FSR1H 
	MOVF        decodePacket_uintCRC_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      decodePacket_uintLength_L1+0, 1 
	INCF        decodePacket_uintLength_L1+1, 1 
;ModbusSlave.c,715 :: 		aryBuffer[uintLength++] = Hi(uintCRC);
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       decodePacket_uintLength_L1+0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      decodePacket_uintLength_L1+1, 0 
	MOVWF       FSR1H 
	MOVF        decodePacket_uintCRC_L0+1, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      decodePacket_uintLength_L1+0, 1 
	INCF        decodePacket_uintLength_L1+1, 1 
;ModbusSlave.c,717 :: 		CREN_bit = 0;
	BCF         CREN_bit+0, 4 
;ModbusSlave.c,718 :: 		RCIE_bit = 0;
	BCF         RCIE_bit+0, 5 
;ModbusSlave.c,720 :: 		TXEN_bit = 1;
	BSF         TXEN_bit+0, 5 
;ModbusSlave.c,721 :: 		Tx_dir = 1;
	BSF         LATE+0, 0 
;ModbusSlave.c,723 :: 		bytRxphase = 128;
	MOVLW       128
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,725 :: 		TXREG = aryBuffer[0];
	MOVF        ModbusSlave_aryBuffer+0, 0 
	MOVWF       TXREG+0 
;ModbusSlave.c,727 :: 		aryBuffer[0] = uintLength;
	MOVF        decodePacket_uintLength_L1+0, 0 
	MOVWF       ModbusSlave_aryBuffer+0 
;ModbusSlave.c,728 :: 		bytIndex = 2;
	MOVLW       2
	MOVWF       ModbusSlave_bytIndex+0 
;ModbusSlave.c,730 :: 		while( !TXIF_bit ){}
L_decodePacket159:
	BTFSC       TXIF_bit+0, 4 
	GOTO        L_decodePacket160
	GOTO        L_decodePacket159
L_decodePacket160:
;ModbusSlave.c,731 :: 		TXREG = aryBuffer[1];
	MOVF        ModbusSlave_aryBuffer+1, 0 
	MOVWF       TXREG+0 
;ModbusSlave.c,733 :: 		TXIE_bit = 1;
	BSF         TXIE_bit+0, 4 
;ModbusSlave.c,734 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,735 :: 		}
L_decodePacket155:
;ModbusSlave.c,736 :: 		}
L_decodePacket86:
;ModbusSlave.c,738 :: 		bytIndex = 0;
	CLRF        ModbusSlave_bytIndex+0 
;ModbusSlave.c,739 :: 		bytRxphase = 1;
	MOVLW       1
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,740 :: 		}
L_end_decodePacket:
	RETURN      0
; end of _decodePacket

_modbusSerialInit:

;ModbusSlave.c,753 :: 		int modbusSerialInit(baudRate eBaud, const byte bytStopBits, ...) {
;ModbusSlave.c,758 :: 		va_start(ap, bytStopBits);
	MOVLW       FARG_modbusSerialInit_bytStopBits+1
	MOVWF       modbusSerialInit_ap_L0+0 
	MOVLW       hi_addr(FARG_modbusSerialInit_bytStopBits+1)
	MOVWF       modbusSerialInit_ap_L0+1 
;ModbusSlave.c,760 :: 		bytSlaveAddress = va_arg(ap, byte);
	MOVLW       modbusSerialInit_ap_L0+0
	MOVWF       R2 
	MOVLW       hi_addr(modbusSerialInit_ap_L0+0)
	MOVWF       R3 
	MOVFF       R2, FSR0
	MOVFF       R3, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_bytSlaveAddress+0 
	MOVFF       R2, FSR0
	MOVFF       R3, FSR0H
	MOVLW       1
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R2, FSR1
	MOVFF       R3, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,762 :: 		memset(aryBuffer, 0, sizeof(aryBuffer));
	MOVLW       ModbusSlave_aryBuffer+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	MOVLW       0
	MOVWF       FARG_memset_n+0 
	MOVLW       1
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;ModbusSlave.c,764 :: 		uintRxGap = 0;
	CLRF        ModbusSlave_uintRxGap+0 
	CLRF        ModbusSlave_uintRxGap+1 
;ModbusSlave.c,766 :: 		exceptionCode = NO_EXCEPTION;
	CLRF        ModbusSlave_exceptionCode+0 
;ModbusSlave.c,768 :: 		switch( eBaud ) {
	GOTO        L_modbusSerialInit161
;ModbusSlave.c,769 :: 		case BAUD_1200:
L_modbusSerialInit163:
;ModbusSlave.c,770 :: 		UART1_Init(BAUD_1200 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       26
	MOVWF       SPBRGH+0 
	MOVLW       10
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,771 :: 		lngTimeoutPreset = GAP_SETPT_1200;
	MOVLW       234
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       60
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       2
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,772 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,773 :: 		case BAUD_2400:
L_modbusSerialInit164:
;ModbusSlave.c,774 :: 		UART1_Init(BAUD_2400 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       13
	MOVWF       SPBRGH+0 
	MOVLW       4
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,775 :: 		lngTimeoutPreset = GAP_SETPT_2400;
	MOVLW       117
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       30
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       1
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,776 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,777 :: 		case BAUD_4800:
L_modbusSerialInit165:
;ModbusSlave.c,778 :: 		UART1_Init(BAUD_4800 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       6
	MOVWF       SPBRGH+0 
	MOVLW       130
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,779 :: 		lngTimeoutPreset = GAP_SETPT_4800;
	MOVLW       58
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       143
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,780 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,781 :: 		case BAUD_9600:
L_modbusSerialInit166:
;ModbusSlave.c,782 :: 		UART1_Init(BAUD_9600 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       3
	MOVWF       SPBRGH+0 
	MOVLW       64
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,783 :: 		lngTimeoutPreset = GAP_SETPT_9600;
	MOVLW       157
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       71
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,784 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,785 :: 		case BAUD_19200:
L_modbusSerialInit167:
;ModbusSlave.c,786 :: 		UART1_Init(BAUD_19200 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       1
	MOVWF       SPBRGH+0 
	MOVLW       160
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,787 :: 		lngTimeoutPreset = GAP_SETPT_19200;
	MOVLW       206
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       35
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,788 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,789 :: 		case BAUD_38400:
L_modbusSerialInit168:
;ModbusSlave.c,790 :: 		UART1_Init(BAUD_38400 * 100);
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       207
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,791 :: 		lngTimeoutPreset = GAP_SETPT_38400;
	MOVLW       231
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       17
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,792 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,793 :: 		case BAUD_57600:
L_modbusSerialInit169:
;ModbusSlave.c,794 :: 		UART1_Init(BAUD_57600 * 100);
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       138
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,795 :: 		lngTimeoutPreset = GAP_SETPT_57600;
	MOVLW       239
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       11
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,796 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,797 :: 		case BAUD_115200:
L_modbusSerialInit170:
;ModbusSlave.c,798 :: 		UART1_Init(BAUD_115200 * 100);
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       68
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,799 :: 		lngTimeoutPreset = GAP_SETPT_115200;
	MOVLW       247
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+0 
	MOVLW       5
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSerialInit_lngTimeoutPreset_L0+3 
;ModbusSlave.c,800 :: 		break;
	GOTO        L_modbusSerialInit162
;ModbusSlave.c,801 :: 		default:
L_modbusSerialInit171:
;ModbusSlave.c,802 :: 		return -1;
	MOVLW       255
	MOVWF       R0 
	MOVLW       255
	MOVWF       R1 
	GOTO        L_end_modbusSerialInit
;ModbusSlave.c,803 :: 		}
L_modbusSerialInit161:
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit246
	MOVLW       12
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit246:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit163
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit247
	MOVLW       24
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit247:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit164
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit248
	MOVLW       48
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit248:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit165
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit249
	MOVLW       96
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit249:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit166
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit250
	MOVLW       192
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit250:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit167
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit251
	MOVLW       128
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit251:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit168
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit252
	MOVLW       64
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit252:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit169
	MOVF        FARG_modbusSerialInit_eBaud+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit253
	MOVLW       128
	XORWF       FARG_modbusSerialInit_eBaud+0, 0 
L__modbusSerialInit253:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit170
	GOTO        L_modbusSerialInit171
L_modbusSerialInit162:
;ModbusSlave.c,805 :: 		Delay_ms(100);
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_modbusSerialInit172:
	DECFSZ      R13, 1, 1
	BRA         L_modbusSerialInit172
	DECFSZ      R12, 1, 1
	BRA         L_modbusSerialInit172
	DECFSZ      R11, 1, 1
	BRA         L_modbusSerialInit172
;ModbusSlave.c,809 :: 		T0CON.TMR0ON = 0;// Timer0 On/Off Control bit 1=Enables / 0=Stops
	BCF         T0CON+0, 7 
;ModbusSlave.c,810 :: 		T0CON.T08BIT = 0;// Timer0 8-bit/16-bit Control bit: 1=8-bit/ 0=16-bit
	BCF         T0CON+0, 6 
;ModbusSlave.c,811 :: 		T0CON.T0CS   = 0;// TMR0 Clock Source Select bit: 0=Internal
	BCF         T0CON+0, 5 
;ModbusSlave.c,812 :: 		T0CON.T0SE   = 0;// TMR0 Source Edge Select bit: 0=low/high
	BCF         T0CON+0, 4 
;ModbusSlave.c,813 :: 		T0CON.PSA    = 1;// Prescaler Assignment bit: 1=NOT assigned/bypassed
	BSF         T0CON+0, 3 
;ModbusSlave.c,814 :: 		T0CON.T0PS2  = 0;// bits 2-0  PS2:PS0: Prescaler Select bits
	BCF         T0CON+0, 2 
;ModbusSlave.c,815 :: 		T0CON.T0PS1  = 0;
	BCF         T0CON+0, 1 
;ModbusSlave.c,816 :: 		T0CON.T0PS0  = 0;
	BCF         T0CON+0, 0 
;ModbusSlave.c,818 :: 		bytTemp = 0;
	CLRF        modbusSerialInit_bytTemp_L0+0 
;ModbusSlave.c,819 :: 		while( lngTimeoutPreset > 29126 ) {
L_modbusSerialInit173:
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       modbusSerialInit_lngTimeoutPreset_L0+3, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit254
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit254
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+1, 0 
	SUBLW       113
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSerialInit254
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+0, 0 
	SUBLW       198
L__modbusSerialInit254:
	BTFSC       STATUS+0, 0 
	GOTO        L_modbusSerialInit174
;ModbusSlave.c,820 :: 		lngTimeoutPreset >>= 1;
	RRCF        modbusSerialInit_lngTimeoutPreset_L0+3, 1 
	RRCF        modbusSerialInit_lngTimeoutPreset_L0+2, 1 
	RRCF        modbusSerialInit_lngTimeoutPreset_L0+1, 1 
	RRCF        modbusSerialInit_lngTimeoutPreset_L0+0, 1 
	BCF         modbusSerialInit_lngTimeoutPreset_L0+3, 7 
	BTFSC       modbusSerialInit_lngTimeoutPreset_L0+3, 6 
	BSF         modbusSerialInit_lngTimeoutPreset_L0+3, 7 
;ModbusSlave.c,821 :: 		bytTemp++;
	INCF        modbusSerialInit_bytTemp_L0+0, 1 
;ModbusSlave.c,822 :: 		}
	GOTO        L_modbusSerialInit173
L_modbusSerialInit174:
;ModbusSlave.c,823 :: 		if ( bytTemp > 0 && bytTemp <= 8 ) {
	MOVF        modbusSerialInit_bytTemp_L0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_modbusSerialInit177
	MOVF        modbusSerialInit_bytTemp_L0+0, 0 
	SUBLW       8
	BTFSS       STATUS+0, 0 
	GOTO        L_modbusSerialInit177
L__modbusSerialInit194:
;ModbusSlave.c,824 :: 		T0CON.PSA = 0;   // Prescaler assigned
	BCF         T0CON+0, 3 
;ModbusSlave.c,825 :: 		T0CON = T0CON | (--bytTemp & 0x07);
	DECF        modbusSerialInit_bytTemp_L0+0, 1 
	MOVLW       7
	ANDWF       modbusSerialInit_bytTemp_L0+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	IORWF       T0CON+0, 1 
;ModbusSlave.c,826 :: 		}
L_modbusSerialInit177:
;ModbusSlave.c,827 :: 		uintRxGapSetPt1 = (uint)-(lngTimeoutPreset >> 1);   // 1 char
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+0, 0 
	MOVWF       R0 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+1, 0 
	MOVWF       R1 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+2, 0 
	MOVWF       R2 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+3, 0 
	MOVWF       R3 
	RRCF        R3, 1 
	RRCF        R2, 1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R3, 7 
	BTFSC       R3, 6 
	BSF         R3, 7 
	MOVF        R0, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt1+0 
	MOVF        R1, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt1+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt1+1, 1 
;ModbusSlave.c,828 :: 		uintRxGapSetPt2 = (uint)-lngTimeoutPreset;          // 2 chars
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+0, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt2+0 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+1, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt2+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt2+1, 1 
;ModbusSlave.c,829 :: 		uintRxGapSetPt3 = (uint)-(lngTimeoutPreset*5 >> 2); // 2.5 chars
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+0, 0 
	MOVWF       R0 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+1, 0 
	MOVWF       R1 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+2, 0 
	MOVWF       R2 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+3, 0 
	MOVWF       R3 
	MOVLW       5
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	MOVF        R4, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt3+0 
	MOVF        R5, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt3+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt3+1, 1 
;ModbusSlave.c,830 :: 		uintRxGapSetPt  = (uint)-(lngTimeoutPreset*9 >> 2); // 4.5 chars
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+0, 0 
	MOVWF       R0 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+1, 0 
	MOVWF       R1 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+2, 0 
	MOVWF       R2 
	MOVF        modbusSerialInit_lngTimeoutPreset_L0+3, 0 
	MOVWF       R3 
	MOVLW       9
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	MOVF        R4, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt+0 
	MOVF        R5, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt+1, 1 
;ModbusSlave.c,832 :: 		if ( bytStopBits != 1 ) {
	MOVF        FARG_modbusSerialInit_bytStopBits+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSerialInit178
;ModbusSlave.c,833 :: 		TX9_bit  = 1;
	BSF         TX9_bit+0, 6 
;ModbusSlave.c,834 :: 		TX9D_bit = 1;
	BSF         TX9D_bit+0, 0 
;ModbusSlave.c,835 :: 		}
L_modbusSerialInit178:
;ModbusSlave.c,838 :: 		restartRx();
	CALL        ModbusSlave_restartRx+0, 0
;ModbusSlave.c,839 :: 		TMR0IE_bit = 1;
	BSF         TMR0IE_bit+0, 5 
;ModbusSlave.c,841 :: 		PEIE_bit   = 1;
	BSF         PEIE_bit+0, 6 
;ModbusSlave.c,843 :: 		GIE_bit    = 1;
	BSF         GIE_bit+0, 7 
;ModbusSlave.c,844 :: 		}
L_end_modbusSerialInit:
	RETURN      0
; end of _modbusSerialInit
